/* pqueue.h */

#ifndef Y_UTIL_PQUEUE_H
#define Y_UTIL_PQUEUE_H

struct PQueue;

struct PQueue *pqueueCreate (int (*comparisonFunction)(void *obj1, void *obj2));

void          pqueueDestroy (struct PQueue *,
                             void (*destructorFunction)(void *obj));

void          pqueueInsert (struct PQueue *, void *obj);

void *        pqueueGetNext (struct PQueue *);
void *        pqueuePeekNext (const struct PQueue *);

int           pqueueLength (const struct PQueue *);

void          pqueueRemove (struct PQueue *, void *userData, int (*testFunction)(void *obj, void *data));

#endif

/* arch-tag: ef9aff25-3610-4d7a-a59a-b6307ec11010
 */
