
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <Y/libY.h>

int
main (int argc, char **argv)
{
  int i, l;
  struct Message req, rep;
  char *data;

  if (argc == 0)
    return EXIT_SUCCESS;

  yInitialise ();

  l = 0;
  for (i=1; i<argc; ++i)
    {
      l += strlen (argv[i]) + 1;
    }

  data = malloc (l);

  strcpy (data, argv[1]);
  for (i=2; i<argc; ++i)
    {
      strcat (data, "\x1c");
      strcat (data, argv[i]);
    }

  req.data = data;
  req.len = l;
  req.to = 0;
  req.from = 0;
  req.cid = 0;
  req.oid = 0;
  req.op = YMO_INVOKE_SPECIAL;
  req.meta = 1;
  req.ext = 0;

  ySend (&req);
  if (yReceive (&rep, -1))
    {
      char *d = rep.data;
      int l = rep.len;
      size_t s;
      while (l > 0)
        {
          s = strcspn (d, "\x1c");
          if (s == 0)
            break;
          printf ("%.*s\n", s, d);
          d += s + 1;
          l -= s + 1;
        }
    }
  else
    printf ("No reply received.\n");

  yFinalise ();

  return EXIT_SUCCESS;
}

/* arch-tag: 854a2dbd-cc0e-4a49-9ae9-9031e4ca590c
 */
