
#include <Y/c++/checkbox.h>
#include <Y/c++/y.h>

#include <iostream>

using std::cout;
using std::endl;

int Y::CheckBox::checkboxClassId = 0;

Y::CheckBox::CheckBox ()
{
  if (checkboxClassId == 0)
    checkboxClassId = Y::Y::findClassId ("CheckBox");

  create (checkboxClassId);

  subscribeSignal ("clicked");
}

Y::CheckBox::~CheckBox ()
{
}

void
Y::CheckBox::onEvent (const string &name, const vector<string>& params)
{
  if (name == "clicked" && params.size () >= 1)
    {
      clicked (params[1] == "1");
    }
} 


/* arch-tag: 93e2077b-068d-4cd9-a63f-1eb1d012b8cc
 */
