
#include <Y/c++/menu.h>
#include <Y/c++/y.h>

#include <sstream>

using std::ostringstream;

int Y::Menu::menuClassId = 0;

Y::Menu::Menu ()
{
  if (menuClassId == 0)
    menuClassId = Y::Y::findClassId ("Menu");

  subscribeSignal ("clicked"); 

  create (menuClassId);
}

void
Y::Menu::addItem (int id, const string &text, Menu *submenu)
{
  ostringstream ss;
  ss << "addItem" << Y::sep << id
                  << Y::sep << text
                  << Y::sep << (submenu == NULL ? 0 : submenu -> getId ());
  invokeMethod (ss.str ());
}

Y::Menu::~Menu ()
{
}


/* arch-tag: 84cb372b-761b-42c5-b138-1f09519d6061
 */
