#ifndef Y_MODULES_THEME_H
#define Y_MODULES_THEME_H

#include <Y/y.h>
#include <Y/text/font.h>
#include <Y/modules/theme_interface.h>

void themeDrawBackgroundPane   (struct Painter *, int x, int y, int w, int h);
void themeDrawButtonPane       (struct Painter *, int x, int y, int w, int h,
                                enum WidgetState state);

struct Font *
     themeGetDefaultFont       ();

void themeWindowInit           (struct Window *);
void themeWindowPaint          (struct Window *, struct Painter *);
int  themeWindowPointerMotion  (struct Window *, int, int, int, int);
int  themeWindowPointerButton  (struct Window *, int, int, int, int);
void themeWindowReconfigure    (struct Window *, int *, int *, int *, int *,
                                int *, int *);
void themeWindowResize         (struct Window *);

#endif /* header guard */

/* arch-tag: c84878a9-90e5-43f8-87cf-b8008be413dd
 */
