#ifndef Y_MODULES_WINDOWMANAGER_H
#define Y_MODULES_WINDOWMANAGER_H

struct WindowManager;

#include <Y/y.h>
#include <Y/widget/widget.h>
#include <Y/widget/window.h>
#include <Y/screen/renderer.h>
#include <Y/util/rectangle.h>

void windowmanagerRegister (struct WindowManager *);

void           wmKeyboard (int, int, int);

void           wmRegisterWindow (struct Window *);
void           wmUnregisterWindow (struct Window *);
void           wmWindowPointerButton (struct Window *, int, int, int, int);
void           wmWindowPointerMotion (struct Window *, int, int, int, int);
void           wmWindowPointerEnter (struct Window *, int, int);
void           wmWindowPointerLeave (struct Window *);

struct Window *wmSelectedWindow ();
void           wmSelectWindow (struct Window *);
void           wmMaximiseWindow (struct Window *);
void           wmRestoreWindow (struct Window *);

#endif /* macro guard */

/* arch-tag: c6156976-3148-4b1a-bc2c-3b5f54be4bec
 */
