
#include <Y/c++/button.h>
#include <Y/c++/y.h>

#include <iostream>

using std::cout;
using std::endl;

int Y::Button::buttonClassId = 0;

Y::Button::Button ()
{
  if (buttonClassId == 0)
    buttonClassId = Y::Y::findClassId ("Button");

  create (buttonClassId);

  subscribeSignal ("clicked");
}

Y::Button::~Button ()
{
}

void
Y::Button::onEvent (const string &name, const vector<string>& params)
{
  if (name == "clicked")
    {
      clicked ();
    }
} 


/* arch-tag: 3f2612a8-50af-4114-a305-a2476fec119b
 */
